> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/guardrails/update.md).

# Update Guardrail

Updates an existing guardrail. A new version is created automatically.

## Request

```http
PUT /umbraco/ai/management/api/v1/guardrails/{guardrailIdOrAlias}
```

### Path Parameters

| Parameter            | Type   | Description             |
| -------------------- | ------ | ----------------------- |
| `guardrailIdOrAlias` | string | Guardrail GUID or alias |

### Request Body

{% code title="Request" %}

```json
{
    "alias": "content-safety",
    "name": "Content Safety Policy v2",
    "rules": [
        {
            "id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
            "evaluatorId": "contains",
            "name": "Block competitor mentions",
            "phase": "PostGenerate",
            "action": "Block",
            "config": {
                "searchPattern": "CompetitorBrand",
                "ignoreCase": true
            },
            "sortOrder": 0
        },
        {
            "id": "b2c3d4e5-f6a7-8901-bcde-f12345678901",
            "evaluatorId": "regex",
            "name": "Block SSNs in responses",
            "phase": "PostGenerate",
            "action": "Block",
            "config": {
                "pattern": "\\b\\d{3}-\\d{2}-\\d{4}\\b",
                "ignoreCase": false
            },
            "sortOrder": 1
        },
        {
            "evaluatorId": "llm-judge",
            "name": "Quality check",
            "phase": "PostGenerate",
            "action": "Warn",
            "config": {
                "evaluationCriteria": "Evaluate whether the response follows brand guidelines.",
                "safetyThreshold": 0.7
            },
            "sortOrder": 2
        }
    ]
}
```

{% endcode %}

{% hint style="info" %}
Include existing rule IDs to update them. Rules without IDs are created as new. Omitting an existing rule removes it.
{% endhint %}

## Response

### Success

{% code title="200 OK" %}

```
(empty response body)
```

{% endcode %}

### Not Found

{% code title="404 Not Found" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.4",
    "title": "Guardrail not found",
    "status": 404,
    "detail": "The specified guardrail could not be found."
}
```

{% endcode %}

### Validation Error

{% code title="400 Bad Request" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.1",
    "title": "Duplicate alias",
    "status": 400,
    "detail": "A guardrail with this alias already exists."
}
```

{% endcode %}

## Examples

{% code title="cURL" %}

```bash
curl -X PUT "https://your-site.com/umbraco/ai/management/api/v1/guardrails/3fa85f64-5717-4562-b3fc-2c963f66afa6" \
  -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  -d '{
    "alias": "content-safety",
    "name": "Content Safety Policy v2",
    "rules": [
      {
        "id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
        "evaluatorId": "contains",
        "name": "Block competitor mentions",
        "phase": "PostGenerate",
        "action": "Block",
        "config": { "searchPattern": "CompetitorBrand", "ignoreCase": true },
        "sortOrder": 0
      }
    ]
  }'
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/guardrails/update.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
